diff --git a/web/pgadmin/feature_tests/browser_tool_bar_test.py b/web/pgadmin/feature_tests/browser_tool_bar_test.py
index 01c7bc548..2d504d8ae 100644
--- a/web/pgadmin/feature_tests/browser_tool_bar_test.py
+++ b/web/pgadmin/feature_tests/browser_tool_bar_test.py
@@ -10,9 +10,8 @@
 from __future__ import print_function
 import sys
 import random
-import time
-
 from regression.python_test_utils import test_utils
+from regression.feature_utils.locators import BrowserToolBarLocators
 from regression.feature_utils.base_feature_test import BaseFeatureTest
 from selenium.common.exceptions import TimeoutException, \
     StaleElementReferenceException
@@ -57,27 +56,25 @@ class BrowserToolBarFeatureTest(BaseFeatureTest):
 
     def after(self):
         self.page.remove_server(self.server)
+        test_utils.delete_table(self.server, self.test_db,
+                                self.test_table_name)
 
-    def _locate_database_tree_node(self):
+    def test_query_tool_button(self):
         self.page.toggle_open_tree_item(self.server['name'])
         self.page.toggle_open_tree_item('Databases')
         self.page.toggle_open_tree_item(self.test_db)
-
-    def test_query_tool_button(self):
-        self._locate_database_tree_node()
-
         retry_count = 0
         while retry_count < 5:
             try:
                 self.page.find_by_css_selector(
-                    ".wcFrameButton[title='Query Tool']:not(.disabled)")\
+                    BrowserToolBarLocators.open_query_tool_button_css)\
                     .click()
                 break
-            except StaleElementReferenceException:
+            except (StaleElementReferenceException, TimeoutException):
                 retry_count += 1
 
-        time.sleep(0.5)
-        self.page.find_by_css_selector(".wcPanelTab .wcTabIcon.fa.fa-bolt")
+        self.page.find_by_css_selector(
+            BrowserToolBarLocators.query_tool_panel_css)
 
     def test_view_data_tool_button(self):
         self.page.select_tree_item(self.test_db)
@@ -90,26 +87,23 @@ class BrowserToolBarFeatureTest(BaseFeatureTest):
         while retry_count < 5:
             try:
                 self.page.find_by_css_selector(
-                    ".wcFrameButton[title='View Data']:not(.disabled)").click()
+                    BrowserToolBarLocators.view_table_data_button_css).click()
                 break
-            except StaleElementReferenceException:
+            except (StaleElementReferenceException, TimeoutException):
                 retry_count += 1
-
-        time.sleep(0.5)
-        self.page.find_by_css_selector(".wcPanelTab .wcTabIcon.fa.fa-bolt")
+        self.page.find_by_css_selector(
+            BrowserToolBarLocators.view_data_panel_css)
 
     def test_filtered_rows_tool_button(self):
         retry_count = 0
         while retry_count < 5:
             try:
                 self.page.find_by_css_selector(
-                    ".wcFrameButton[title='Filtered Rows']:not(.disabled)")\
+                    BrowserToolBarLocators.filter_data_button_css)\
                     .click()
                 break
-            except StaleElementReferenceException:
+            except (StaleElementReferenceException, TimeoutException):
                 retry_count += 1
-
-        time.sleep(0.5)
         self.page.find_by_css_selector(
-            ".alertify .ajs-header[data-title~='Filter']")
+            BrowserToolBarLocators.filter_alertify_box_css)
         self.page.click_modal('Cancel')
diff --git a/web/pgadmin/feature_tests/copy_selected_query_results_feature_test.py b/web/pgadmin/feature_tests/copy_selected_query_results_feature_test.py
index 0837b84a9..1b97b3e9c 100644
--- a/web/pgadmin/feature_tests/copy_selected_query_results_feature_test.py
+++ b/web/pgadmin/feature_tests/copy_selected_query_results_feature_test.py
@@ -9,11 +9,11 @@
 
 import pyperclip
 import random
-
 from selenium.webdriver import ActionChains
 from selenium.webdriver.common.keys import Keys
 from regression.python_test_utils import test_utils
 from regression.feature_utils.base_feature_test import BaseFeatureTest
+from regression.feature_utils.locators import QueryToolLocators
 
 
 class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
@@ -32,10 +32,9 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
         # Create test table with random name to avoid same name conflicts in
         # parallel execution
         self.test_table_name = "test_table" + str(random.randint(1000, 3000))
-
+        self.page.add_server(self.server)
         test_utils.create_table(
             self.server, self.test_db, self.test_table_name)
-        self.page.add_server(self.server)
 
     def runTest(self):
         self.page.toggle_open_tree_item(self.server['name'])
@@ -46,7 +45,8 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
         self.page.fill_codemirror_area_with(
             "SELECT * FROM %s ORDER BY some_column" % self.test_table_name)
 
-        self.page.find_by_id("btn-flash").click()
+        self.page.find_by_css_selector(
+            QueryToolLocators.btn_execute_query_css).click()
 
         self._copies_rows()
         self._copies_columns()
@@ -59,21 +59,26 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
 
     def _copies_rows(self):
         pyperclip.copy("old clipboard contents")
-        self.page.find_by_xpath(
-            "//*[contains(@class, 'slick-row')]/*[1]").click()
+        first_row = self.page.find_by_xpath(
+            QueryToolLocators.output_row_xpath.format(1))
+        first_row.click()
 
-        self.page.find_by_xpath("//*[@id='btn-copy-row']").click()
+        copy_button = self.page.find_by_css_selector(
+            QueryToolLocators.copy_button_css)
+        copy_button.click()
 
         self.assertEqual('"Some-Name"\t"6"\t"some info"',
                          pyperclip.paste())
 
     def _copies_columns(self):
         pyperclip.copy("old clipboard contents")
-        self.page.find_by_xpath(
-            "//*[@data-test='output-column-header' and "
-            "contains(., 'some_column')]"
-        ).click()
-        self.page.find_by_xpath("//*[@id='btn-copy-row']").click()
+        column = self.page.find_by_css_selector(
+            QueryToolLocators.output_column_header_css.format('some_column'))
+        column.click()
+
+        copy_button = self.page.find_by_css_selector(
+            QueryToolLocators.copy_button_css)
+        copy_button.click()
 
         self.assertEqual(
             """\"Some-Name"
@@ -83,8 +88,9 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
 
     def _copies_row_using_keyboard_shortcut(self):
         pyperclip.copy("old clipboard contents")
-        self.page.find_by_xpath(
-            "//*[contains(@class, 'slick-row')]/*[1]").click()
+        first_row = self.page.find_by_xpath(
+            QueryToolLocators.output_row_xpath.format(1))
+        first_row.click()
 
         ActionChains(self.page.driver).key_down(
             Keys.CONTROL).send_keys('c').key_up(Keys.CONTROL).perform()
@@ -94,10 +100,9 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
 
     def _copies_column_using_keyboard_shortcut(self):
         pyperclip.copy("old clipboard contents")
-        self.page.find_by_xpath(
-            "//*[@data-test='output-column-header' and "
-            "contains(., 'some_column')]"
-        ).click()
+        column = self.page.find_by_css_selector(
+            QueryToolLocators.output_column_header_css.format('some_column'))
+        column.click()
 
         ActionChains(self.page.driver).key_down(
             Keys.CONTROL).send_keys('c').key_up(Keys.CONTROL).perform()
@@ -111,12 +116,12 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
     def _copies_rectangular_selection(self):
         pyperclip.copy("old clipboard contents")
 
-        top_left_cell = self.page.find_by_xpath(
-            "//div[contains(@class, 'slick-cell') and "
-            "contains(., 'Some-Other-Name')]"
-        )
+        top_left_cell = \
+            self.page.find_by_xpath(
+                QueryToolLocators.output_column_data_xpath.
+                format('Some-Other-Name'))
         bottom_right_cell = self.page.find_by_xpath(
-            "//div[contains(@class, 'slick-cell') and contains(., '14')]")
+            QueryToolLocators.output_column_data_xpath.format('14'))
 
         ActionChains(
             self.page.driver
@@ -135,11 +140,11 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
         pyperclip.copy("old clipboard contents")
 
         top_left_cell = self.page.find_by_xpath(
-            "//div[contains(@class, 'slick-cell') and "
-            "contains(., 'Some-Other-Name')]"
+            QueryToolLocators.output_column_data_xpath.
+            format('Some-Other-Name')
         )
         initial_bottom_right_cell = self.page.find_by_xpath(
-            "//div[contains(@class, 'slick-cell') and contains(., '14')]")
+            QueryToolLocators.output_column_data_xpath.format('14'))
         ActionChains(
             self.page.driver
         ).click_and_hold(top_left_cell).move_to_element(
@@ -160,10 +165,10 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
     def _shift_resizes_column_selection(self):
         pyperclip.copy("old clipboard contents")
 
-        self.page.find_by_xpath(
-            "//*[@data-test='output-column-header' and "
-            "contains(., 'value')]"
-        ).click()
+        column = self.page.find_by_css_selector(
+            QueryToolLocators.output_column_header_css.format('value')
+        )
+        column.click()
 
         ActionChains(self.page.driver).key_down(
             Keys.SHIFT).send_keys(Keys.ARROW_LEFT).key_up(Keys.SHIFT).perform()
@@ -181,11 +186,11 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
         pyperclip.copy("old clipboard contents")
 
         bottom_right_cell = self.page.find_by_xpath(
-            "//div[contains(@class, 'slick-cell') and "
-            "contains(., 'cool info')]"
+            QueryToolLocators.output_column_data_xpath.format('cool info')
         )
 
-        load_button = self.page.find_by_xpath("//button[@id='btn-load-file']")
+        load_button = self.page.find_by_css_selector(
+            QueryToolLocators.btn_load_file_css)
         ActionChains(self.page.driver).click_and_hold(bottom_right_cell) \
             .move_to_element(load_button) \
             .release(load_button) \
@@ -199,3 +204,5 @@ class CopySelectedQueryResultsFeatureTest(BaseFeatureTest):
     def after(self):
         self.page.close_query_tool()
         self.page.remove_server(self.server)
+        test_utils.delete_table(self.server, self.test_db,
+                                self.test_table_name)
diff --git a/web/pgadmin/feature_tests/file_manager_test.py b/web/pgadmin/feature_tests/file_manager_test.py
index b6b35c047..3df37af84 100644
--- a/web/pgadmin/feature_tests/file_manager_test.py
+++ b/web/pgadmin/feature_tests/file_manager_test.py
@@ -9,15 +9,16 @@
 
 from __future__ import print_function
 import os
-import time
 import sys
-
+import time
 from selenium.webdriver.common.keys import Keys
 from selenium.webdriver.support.ui import WebDriverWait
 from selenium.webdriver.common.by import By
+from selenium.common.exceptions import StaleElementReferenceException, \
+    TimeoutException
 from selenium.webdriver.support import expected_conditions as EC
 from regression.feature_utils.base_feature_test import BaseFeatureTest
-from .locators import QueryToolLocatorsCss
+from regression.feature_utils.locators import QueryToolLocators
 
 
 class CheckFileManagerFeatureTest(BaseFeatureTest):
@@ -65,32 +66,40 @@ class CheckFileManagerFeatureTest(BaseFeatureTest):
         self.page.open_query_tool()
 
     def _create_new_file(self):
-        self.page.find_by_css_selector(QueryToolLocatorsCss.btn_save_file)\
+        self.page.find_by_css_selector(QueryToolLocators.btn_save_file)\
             .click()
         # Set the XSS value in input
         self.page.find_by_css_selector('.change_file_types')
-        self.page.fill_input_by_css_selector("input#file-input-path",
-                                             self.XSS_FILE)
+        self.page.fill_input_by_css_selector(
+            QueryToolLocators.input_file_path_css, self.XSS_FILE)
         # Save the file
         self.page.click_modal('Create')
         self.page.wait_for_query_tool_loading_indicator_to_disappear()
 
     def _open_file_manager_and_check_xss_file(self):
-        self.page.find_by_id("btn-load-file").click()
+        load_file = self.page.find_by_css_selector(
+            QueryToolLocators.btn_load_file_css)
+        load_file.click()
         self.page.find_by_css_selector('.change_file_types')
-        self.page.fill_input_by_css_selector("#file-input-path", "/tmp/",
-                                             key_after_input=Keys.RETURN)
+        self.page.fill_input_by_css_selector(
+            QueryToolLocators.input_file_path_css,
+            "/tmp/", key_after_input=Keys.RETURN)
 
         if self.page.driver.capabilities['browserName'] == 'firefox':
             table = self.page.wait_for_element_to_reload(
-                lambda driver:
-                driver.find_element_by_css_selector("table#contents")
+                lambda driver: driver.find_element_by_css_selector(
+                    QueryToolLocators.select_file_content_css)
             )
         else:
-            table = self.page.driver \
-                .find_element_by_css_selector("table#contents")
-
-        contents = table.get_attribute('innerHTML')
+            table = self.page.driver.find_element_by_css_selector(
+                QueryToolLocators.select_file_content_css)
+        retry_count = 0
+        while retry_count < 5:
+            try:
+                contents = table.get_attribute('innerHTML')
+                break
+            except (StaleElementReferenceException, TimeoutException):
+                retry_count += 1
 
         self.page.click_modal('Cancel')
         self.page.wait_for_query_tool_loading_indicator_to_disappear()
@@ -107,7 +116,9 @@ class CheckFileManagerFeatureTest(BaseFeatureTest):
         ) != -1, "{0} might be vulnerable to XSS ".format(source)
 
     def _check_file_sorting(self):
-        self.page.find_by_id("btn-load-file").click()
+        load_file = self.page.find_by_css_selector(
+            QueryToolLocators.btn_load_file_css)
+        load_file.click()
         self.page.find_by_css_selector("#contents th[data-column='0']")
 
         # Added time.sleep so that the element to be clicked.
@@ -134,7 +145,7 @@ class CheckFileManagerFeatureTest(BaseFeatureTest):
         if not success:
             raise Exception("Unable to sort in ascending order while clicked "
                             "on 'Name' column")
-
+        # Added time.sleep so that the element to be clicked.
         time.sleep(0.05)
 
         # Click and Check for sort Descending
@@ -143,9 +154,10 @@ class CheckFileManagerFeatureTest(BaseFeatureTest):
         iteration = 0
         success = False
         while not success and iteration < 4:
-            self.page.find_by_xpath("//th[@data-column='0']"
-                                    "/div/span[text()='Name']").click()
+
             try:
+                self.page.find_by_xpath("//th[@data-column='0']"
+                                        "/div/span[text()='Name']").click()
                 self.wait.until(
                     EC.presence_of_element_located((
                         By.CSS_SELECTOR,
diff --git a/web/pgadmin/feature_tests/keyboard_shortcut_test.py b/web/pgadmin/feature_tests/keyboard_shortcut_test.py
index bbf0c7963..9ed841337 100644
--- a/web/pgadmin/feature_tests/keyboard_shortcut_test.py
+++ b/web/pgadmin/feature_tests/keyboard_shortcut_test.py
@@ -15,13 +15,14 @@ from selenium.webdriver.support.ui import WebDriverWait
 from selenium.webdriver.support import expected_conditions as EC
 from selenium.webdriver.common.by import By
 from selenium.webdriver import ActionChains
-from regression.feature_utils.base_feature_test import BaseFeatureTest
 from selenium.webdriver.common.keys import Keys
+from regression.feature_utils.base_feature_test import BaseFeatureTest
+from regression.feature_utils.locators import NavMenuLocators
 
 
 class KeyboardShortcutFeatureTest(BaseFeatureTest):
     """
-        This feature test will test the keyboard short is working
+        This feature test will test the keyboard shortcut is working
         properly.
     """
 
@@ -85,23 +86,36 @@ class KeyboardShortcutFeatureTest(BaseFeatureTest):
             print("OK", file=sys.stderr)
 
     def _update_preferences(self):
-        self.page.find_by_id("mnu_file").click()
-        self.page.find_by_id("mnu_preferences").click()
+        file_menu = self.page.find_by_css_selector(
+            NavMenuLocators.file_menu_css)
+        file_menu.click()
 
+        pref_menu_item = self.page.find_by_css_selector(
+            NavMenuLocators.preference_menu_item_css)
+        pref_menu_item.click()
+
+        # Wait till the preference dialogue box is displayed by checking the
+        # visibility of Show System Object label
         self.wait.until(EC.presence_of_element_located(
-            (By.XPATH, "//*[contains(string(), 'Show system objects?')]"))
+            (By.XPATH, NavMenuLocators.show_system_objects_pref_label_xpath))
         )
 
-        self.page.find_by_css_selector(
-            ".ajs-dialog.pg-el-container .ajs-maximize"
-        ).click()
+        maximize_button = self.page.find_by_css_selector(
+            NavMenuLocators.maximize_pref_dialogue_css)
+        maximize_button.click()
+
+        browser_node = self.page.find_by_xpath(
+            NavMenuLocators.specified_preference_tree_node.format('Browser'))
+        if self.page.find_by_xpath(
+            NavMenuLocators.specified_pref_node_exp_status.
+                format('Browser')).get_attribute('aria-expanded') == 'false':
 
-        browser = self.page.find_by_xpath(
-            "//*[contains(@class,'aciTreeLi') and contains(.,'Browser')]")
+            ActionChains(self.driver).double_click(browser_node).perform()
 
-        browser.find_element_by_xpath(
-            "//*[contains(@class,'aciTreeText') and "
-            "contains(.,'Keyboard shortcuts')]").click()
+        keyboard_node = self.page.find_by_xpath(
+            NavMenuLocators.specified_sub_node_of_pref_tree_node.format(
+                'Browser', 'Keyboard shortcuts'))
+        keyboard_node.click()
 
         for s in self.new_shortcuts:
             key = self.new_shortcuts[s]['shortcut'][2]
diff --git a/web/pgadmin/feature_tests/pg_datatype_validation_test.py b/web/pgadmin/feature_tests/pg_datatype_validation_test.py
index 8a5b293be..83a245e57 100644
--- a/web/pgadmin/feature_tests/pg_datatype_validation_test.py
+++ b/web/pgadmin/feature_tests/pg_datatype_validation_test.py
@@ -18,6 +18,8 @@ from selenium.webdriver.common.by import By
 from selenium.webdriver import ActionChains
 from regression.python_test_utils import test_utils
 from regression.feature_utils.base_feature_test import BaseFeatureTest
+from regression.feature_utils.locators import NavMenuLocators, \
+    QueryToolLocators
 
 CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
 
@@ -78,35 +80,42 @@ class PGDataypeFeatureTest(BaseFeatureTest):
         connection.close()
 
     def _update_preferences(self):
-        self.page.find_by_id("mnu_file").click()
-        self.page.find_by_id("mnu_preferences").click()
+        file_menu = self.page.find_by_css_selector(
+            NavMenuLocators.file_menu_css)
+        file_menu.click()
+
+        pref_menu_item = self.page.find_by_css_selector(
+            NavMenuLocators.preference_menu_item_css)
+        pref_menu_item.click()
+
         wait = WebDriverWait(self.page.driver, 10)
 
+        # Wait till the preference dialogue box is displayed by checking the
+        # visibility of Show System Object label
         wait.until(EC.presence_of_element_located(
-            (By.XPATH, "//*[contains(string(), 'Show system objects?')]"))
+            (By.XPATH, NavMenuLocators.show_system_objects_pref_label_xpath))
         )
 
-        self.page.find_by_css_selector(
-            ".ajs-dialog.pg-el-container .ajs-maximize").click()
+        maximize_button = self.page.find_by_css_selector(
+            NavMenuLocators.maximize_pref_dialogue_css)
+        maximize_button.click()
 
         sql_editor = self.page.find_by_xpath(
-            "//*[contains(@class,'aciTreeLi') and contains(.,'Query Tool')]")
-
-        sql_editor.find_element_by_xpath(
-            "//*[contains(@class,'aciTreeText') and contains(.,'Options')]"
-        ).click()
-
-        insert_bracket_pairs_control = self.page.find_by_xpath(
-            "//div[contains(@class,'pgadmin-control-group') and "
-            "contains(.,'Insert bracket pairs?')]"
-        )
-
-        switch_btn = insert_bracket_pairs_control.\
-            find_element_by_class_name('toggle')
-
-        # check if switch is on then only toggle.
-        if 'off' not in switch_btn.get_attribute('class'):
-            switch_btn.click()
+            NavMenuLocators.specified_preference_tree_node.
+            format('Query Tool'))
+        if self.page.find_by_xpath(
+            NavMenuLocators.specified_pref_node_exp_status.
+                format('Query Tool')).\
+                get_attribute('aria-expanded') == 'false':
+            ActionChains(self.driver).double_click(sql_editor).perform()
+
+        option_node = self.page.find_by_xpath(
+            NavMenuLocators.specified_sub_node_of_pref_tree_node.format(
+                'Query Tool', 'Options'))
+        option_node.click()
+
+        self.page.set_switch_box_status(
+            NavMenuLocators.insert_bracket_pair_switch_btn, 'No')
 
         # save and close the preference dialog.
         self.page.click_modal('Save')
@@ -121,8 +130,10 @@ class PGDataypeFeatureTest(BaseFeatureTest):
         'yellow','green','blue','purple');
         """
         self.page.fill_codemirror_area_with(query)
-        self.page.find_by_id("btn-flash").click()
-        self._clear_query_tool()
+        execute_query = self.page.find_by_css_selector(
+            QueryToolLocators.btn_execute_query_css)
+        execute_query.click()
+        self.page.clear_query_tool()
 
     def runTest(self):
         self.page.wait_for_spinner_to_disappear()
@@ -150,7 +161,9 @@ class PGDataypeFeatureTest(BaseFeatureTest):
         for batch in config_data:
             query = self.construct_select_query(batch)
             self.page.fill_codemirror_area_with(query)
-            self.page.find_by_id("btn-flash").click()
+            execute_query = self.page.find_by_css_selector(
+                QueryToolLocators.btn_execute_query_css)
+            execute_query.click()
 
             wait = WebDriverWait(self.page.driver, 5)
 
@@ -168,12 +181,13 @@ class PGDataypeFeatureTest(BaseFeatureTest):
             ))
 
             canvas = wait.until(EC.presence_of_element_located(
-                (By.CSS_SELECTOR, "#datagrid .slick-viewport .grid-canvas"))
+                (By.CSS_SELECTOR, QueryToolLocators.query_output_canvas_css))
             )
 
             # For every sample data-type value, check the expected output.
             cnt = 2
-            cells = canvas.find_elements_by_css_selector('.slick-cell')
+            cells = canvas.find_elements_by_css_selector(
+                QueryToolLocators.query_output_cells)
             # remove first element as it is row number.
             cells.pop(0)
             for val, cell, datatype in zip(
@@ -202,7 +216,7 @@ class PGDataypeFeatureTest(BaseFeatureTest):
                         "for datatype {0}\n{1} does not match with {2}".format(
                             datatype, val, expected_output
                         )
-            self._clear_query_tool()
+            self.page.clear_query_tool()
 
     def construct_select_query(self, batch):
         query = 'SELECT '
@@ -233,18 +247,6 @@ class PGDataypeFeatureTest(BaseFeatureTest):
                 datatype, source_code, string_to_find
             )
 
-    def _clear_query_tool(self):
-        self.page.click_element(
-            self.page.find_by_xpath("//*[@id='btn-clear-dropdown']")
-        )
-        ActionChains(self.driver)\
-            .move_to_element(self.page.find_by_xpath("//*[@id='btn-clear']"))\
-            .perform()
-        self.page.click_element(
-            self.page.find_by_xpath("//*[@id='btn-clear']")
-        )
-        self.page.click_modal('Yes')
-
     def _is_datatype_available_in_current_database(self, datatype):
         if datatype == '':
             return True
